/**
   Example of creation of a thread
*/
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

void *thread(void *arg)
{
  int a;

  a = rand() % 10;
  
  printf("ARG: %lp\n", arg);

  printf("I am a thread! a = %d\n", a);
  sleep(1);
  printf("Here I am again! a = %d\n", a);
  sleep(1);
  printf("Just before exit: a = %d\n", a);
}

int main()
{
  pthread_t tid, tid2;
  int err;

  err = pthread_create(&tid, 0, thread, &err);
  if (err != 0) 
    perror("An error occurred while creating the thread");

  err = pthread_create(&tid2, 0, thread, 0);
  if (err != 0) 
    perror("An error occurred while creating the thread");

  sleep(1); // change to 1 and see what happens!
  printf("main exits\n");
}


