/**
   Example of passing arguments to a thread
 */
#include <pthread.h>
#include <stdio.h>

#define N 8

void *mybody(void *arg)
{
  int a = *((int *)arg);
  int s = rand()%3+1;

  printf("TH %d:Hello world!\n", a);
  sleep(s);
  printf("TH %d:exiting\n", a);
}


int main()
{
  //int args[N];
  int k;
  pthread_t tids[N];
  int i;

  for (i=0; i<N; i++) {
    //args[i] = i+1; 
    k = i + 1;
    pthread_create(&tids[i], 0, mybody, &k);//&args[i]);
  }
  printf("MN: created all threads, now waiting\n");
  for (i=0; i<N; i++) 
    pthread_join(tids[i], 0);
  printf("MN: exiting\n");
}
