/**
   Example of join.
   Show what happens when removing a \n 
   from the first printf in the main...
 */

#include <pthread.h>
#include <stdio.h>

struct myret {
  int code;
  int value;
} tret;

void *mybody(void *arg)
{
  printf("TH:Hello world\n");
  sleep(2);
  printf("TH:Exiting with code\n");
  tret.code = 5;
  tret.value = 6;
  return &tret;
}

int main()
{
  pthread_t tid;
  struct myret *p;

  pthread_create(&tid, 0, mybody, 0);
  printf("MN:thread created, now waiting for termination\n");
  pthread_join(tid, &p);
  printf("MN:Return: code = %d, value = %d\n",
	 p->code, p->value);
}
